%% Compare stream-based active learning (qbc-pyp) with random sampling (rand)

plotData;

test_rand;
clear all;

test_qbc_pyp;
clear all;

%% Retrieve results and compute mean
nn = 0;
nn = nn + 1; filePath{nn} = 'result_rand/result_%d_%d.mat';
sampMethods{nn} = 'rand';
nn = nn + 1; filePath{nn} = 'result_qbc_pyp/result_%d_%d.mat';
sampMethods{nn} = 'qbc-pyp-s';

noRun        = 5;
noFold       = 2;
activeBudget = 50;

for ii = 1:length(filePath) % for each method
    
    ii_noClass  = zeros(noRun*noFold,activeBudget);
    ii_accuracy = zeros(noRun*noFold,activeBudget);
    ccount      = 1;
    
    for rr = 1:noRun
        for ff = 1:noFold
            fileName = sprintf(strrep(filePath{ii}, '\', '\\'), rr, ff);
            load(fileName);
            
            ii_noClass(ccount,:) = traceAL.noClass;
            ii_accuracy(ccount,:) = traceAL.accuracy;
            
            ccount = ccount + 1;
        end
    end
    
    % Mean accuracy
    meanTraceAL{ii}.accuracy = mean(ii_accuracy);
    
    % Mean discovered class
    meanTraceAL{ii}.noClass = mean(ii_noClass);
end

colors = vsGenPlotColour(length(sampMethods));

%% Plot average accuracy
figure; hold on; box on;
for ii = 1:nn
    plot(meanTraceAL{ii}.accuracy, ...
        'Color', colors(ii,:), ...
        'LineWidth', 3);
end
xlabel('Labelled Points');
ylabel('Average Accuracy');
legend(sampMethods,'Location','Best','FontName','Times','FontSize',16);


%% Plot average number of discovered class
figure; hold on; box on;
for ii = 1:nn
    plot(meanTraceAL{ii}.noClass, ...
        'Color', colors(ii,:), ...
        'LineWidth', 3);
end
xlabel('Labelled Points');
ylabel('Average Accuracy');
legend(sampMethods,'Location','Best','FontName','Times','FontSize',16);