%% Setting

%% Add path with activeLearning main routine

doPlot  = 0;        % plots learning process
budget  = 50;       % max number of queries

% Specify the saving folder
resultPath   = resultFolder;
imagePath = strcat(fullfile(resultPath,'img'),'/img_%.5d.jpg');
imagePath = regexprep(imagePath,'\','/');
mkdir(fullfile(resultPath,'img'));
mkdir(resultPath);

%% Generating\loading data

load('synthetic_ring2.mat');

% Training data
randIndex  = randperm(size(CV(nF).Xtr,1));
dataTrain  = CV(nF).Xtr(randIndex,:)';
labelTrain = CV(nF).Ytro(randIndex);

% Testing data
dataTest   = CV(nF).Xte';
labelTest  = CV(nF).Yteo;

% Number of data in the pool
noDataPool = size(dataTrain,2);

%% Plot settings

if doPlot
    h = figure;
    axislimit    = round(1.02*max(max(abs(dataTrain))));
    totalSubPlot = 3;
    colourLabel  = vsGenPlotColour(length(unique(labelTrain)));
end


%% Model settings

opts               = mkopts_avdp;
opts.initial_K     = 5;
opts.do_greedy     = 0;
opts.do_split      = 1;
opts.do_merge      = 0;
opts.get_q_of_z    = 1;
opts.use_kd_tree   = 0;
opts.splitStrategy = 'bisect_princomp';


