function mix = convert_dpmm(dpmm, covar_type)

% Convert dpmm to a finite mixture model

% Initialisation
mu            =  dpmm.hp_posterior.m(:,1);
mix.type      = 'gmm';
mix.nin       = length(mu);
mix.ncentres  = length(dpmm.hp_posterior.eta)-1;

if nargin < 2
    mix.covar_type = 'full';
else
    mix.covar_type = covar_type;
end

mix.priors    = dpmm.hp_posterior.Nc(1:mix.ncentres)/ ...
    sum(dpmm.hp_posterior.Nc(1:mix.ncentres));
mix.centres   = dpmm.hp_posterior.m(:,1:mix.ncentres)';
mix.covars    = zeros(mix.nin,mix.nin,mix.ncentres);

for nclust = 1:mix.ncentres
    mix.covars(:,:,nclust) =  dpmm.hp_posterior.B{nclust} ...
        / dpmm.hp_posterior.eta(nclust);
end







