
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [new_data, new_q_of_z, updated_I] = expand_all_nodes(data, ...
                                                  q_of_z, hp_posterior, ...
                                                  hp_prior, ...
                                                  target_partitions, opts);
if size(target_partitions, 1) ~= 1
  error('target_partitions must be a row vector.')
end
new_data = data;
for a=target_partitions
  if isempty(data.kdtree(a).children)
    children = mk_children_of_partition(data.kdtree(a));
    data.kdtree(a).children = children;
  else
    children = data.kdtree(a).children;
  end
  if length(children) == 1
    continue
  end
  new_data.kdtree(a) = children(1);
  new_data.kdtree(end+1) = children(2);
end % while a <= length(data.kdtree)
updated_I = [target_partitions length(data.kdtree)+1:length(new_data.kdtree)];
sub_data.given_data = data.given_data;
sub_data.kdtree = new_data.kdtree(updated_I);
sub_q_of_z = mk_q_of_z(sub_data, hp_posterior, hp_prior, opts);
new_q_of_z = zeros(length(new_data.kdtree),size(q_of_z,2));
new_q_of_z(1:size(q_of_z,1),:) = q_of_z;
new_q_of_z(updated_I,:) = sub_q_of_z;
disp(['### building kd-tree done; #partition ' num2str(length(data.kdtree)) ...
      ' -> ' num2str(length(new_data.kdtree))])

