

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [free_energy, hp_posterior, data, hp_prior] = greedy(data, hp_posterior, hp_prior, opts);

free_energy = mk_free_energy(data, hp_posterior, hp_prior, opts);
%disp_status(free_energy, hp_posterior, opts);

while 1
  %disp('finding the best one....')
  [new_free_energy, new_hp_posterior, new_data, c] = find_best_splitting(data, ...
                                                    hp_posterior, ...
                                                    hp_prior, opts);
  if c == -1
    break
  end
  %disp(['finding the best one.... done.  component ' num2str(c) ' was split.'])
  %disp_status(new_free_energy, new_hp_posterior, opts);
  [new_free_energy, new_hp_posterior, new_data] = update_posterior2(new_data, ...
                                                    new_hp_posterior, ...
                                                    hp_prior, opts, 1, opts.ite);
  if free_energy_improved(free_energy, new_free_energy, 0, opts) == 0
    break
  end
  free_energy = new_free_energy;
  hp_posterior = new_hp_posterior;
  data = new_data;
  
  % Update alpha
  if isfield(opts, 'estimate_alpha')
        if opts.estimate_alpha == 1
            hp_prior.alpha = rand_conparam(hp_prior.alpha, ...
                size(data.given_data,2), ...
                length(hp_posterior.eta)-1, ...
                opts.alphaa, opts.alphab,128,128);
        end
  end
  
end
%disp_status(free_energy, hp_posterior, opts);

