
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [E_Nc_minus_n, V_Nc_minus_n] = mk_E_Nc_minus_n(q_of_z)
% returns E[Nc^-n]; the expected value of Nc-n; N by K
%         V[Nc^-n]; the variance of Nc-n;       N by K
% q_of_z : N by K
N = size(q_of_z, 1);
E_Nc_minus_n = repmat(sum(q_of_z, 1), N, 1) - q_of_z;
tmp = q_of_z.*(1-q_of_z);
V_Nc = sum(tmp, 1);
V_Nc_minus_n = repmat(V_Nc, N, 1) - tmp;

