

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [log_likelihood log_likelihood_ind ll_full] = mk_log_likelihood(data, hp_posterior, hp_prior, opts);
[D,N] = size(data.given_data);
K = size(hp_posterior.m, 2);
log_likelihood = zeros(K,N);
E_pi = mk_E_pi(hp_posterior, hp_prior, opts);
for c=1:K
  mu = hp_posterior.m(:,c);
  f = hp_posterior.eta(c) + 1 - D;
  Sigma = (hp_posterior.xi(c)+1) / hp_posterior.xi(c) / f * hp_posterior.B{c};
  log_likelihood(c,:) = log_no_w(E_pi(c)) + logmvtpdf(data.given_data, mu, f, Sigma);
end
ll_full = log_likelihood;
log_likelihood = log_sum_exp(log_likelihood, 1); % 1 by N
log_likelihood_ind = log_likelihood;
log_likelihood = sum(log_likelihood, 2);

