
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function quad_term = mk_quad_term(data, q_of_z, hp_prior, opts)
% calculate the quad_term in marginalizing out means
% quad_term : D by D by K
%
[N, K] = size(q_of_z);
D = size(data.given_data, 1);
Nc = sum(q_of_z, 1); % 1 by K
xi = Nc + hp_prior.xi0;
f0 = 1 ./ (xi.^2);
f1 = - 2 ./ (xi.^3);
f2 = 3 ./ (xi.^4);
v = q_of_z.*(1 - q_of_z); % N by K
c = v.*((1-q_of_z).^2 + q_of_z.^2);
q = v.*((1-q_of_z).^3 + q_of_z.^3);
p_x = data.given_data * q_of_z; % D by K
v_x = data.given_data * v;      % D by K
c_x = data.given_data * c;      % D by K
v_p_x = data.given_data * (q_of_z + v); % D by K
c_p_x = data.given_data * (q_of_z + c); % D by K
for t=1:K
  first_term = f0(t) ...
      *((repmat(v(:,t)', D, 1).*data.given_data)*data.given_data' ...
        + p_x(:,t)*p_x(:,t)');
  second_term = f1(t) ...
      *((repmat(c(:,t)', D, 1).*data.given_data)*data.given_data' ...
        + v_p_x(:,t)*v_p_x(:,t)' - v_x(:,t)*v_x(:,t)' - p_x(:,t)*p_x(:,t)');
  tmp = q(:,t) - 3*v(:,t).^2 + v(:,t)*sum(v(:,t));
  third_term = f2(t) ...
      *((repmat(tmp', D, 1).*data.given_data)*data.given_data' ...
        + c_p_x(:,t)*c_p_x(:,t)' - c_x(:,t)*c_x(:,t)' - p_x(:,t)*p_x(:,t)' ...
        + 2*v_x(:,t)*v_x(:,t)' ...
        + sum(v(:,t))*p_x(:,t)*p_x(:,t)');
  quad_term(:,:,t) = first_term + second_term + third_term;
end

