function [alpha_new beta_new] = rand_condisparam3(alpha,beta, numdata,numclass, ...
    alphaa,alphab,betaa,betab,numburnin,numiter,numitemclass)

alpha_prev = alpha;

if nargin == 8
    numburnin = 128;
    numiter = 128;
end

totalclass = sum(numclass);
alpha_all = zeros(numburnin+numiter,1);
beta_all = zeros(numburnin+numiter,1);

for ii = 1:numburnin+numiter

    xx = betarnd(alpha+1, numdata-1);

    jj_vector = 1:totalclass-1;
    alpha_vector = repmat(alpha,size(jj_vector));
    aa = alpha_vector./(alpha_vector+beta*jj_vector);
    yysum = sum( binornd(ones(size(aa)),aa) );
    
    alpha = gamrnd(alphaa+yysum, alphab-log(xx));
    alpha_all(ii,:) = alpha;

end

alpha_new = mean(alpha_all(numburnin+1:end));

%%
alpha = alpha_prev;

for ii = 1:numburnin+numiter

    jj_vector = 1:totalclass-1;
    alpha_vector = repmat(alpha,size(jj_vector));
    aa = alpha_vector./(alpha_vector+beta*jj_vector);
    yysum = sum( 1 - binornd(ones(size(aa)),aa) );
    
    zzsum = 0;
    for nn = 1:totalclass
        jj_vector = 1:numitemclass(nn)-1;
        beta_vector = repmat(beta,size(jj_vector));
        aa = (jj_vector - 1)./(jj_vector - beta_vector);
        zzsum = zzsum + sum( 1 - binornd(ones(size(aa)),aa) );
    end
    
    beta = betarnd(betaa+yysum, betab+zzsum);
    beta_all(ii,:) = beta;

end

beta_new  = mean(beta_all(numburnin+1:end));
