function alpha = rand_conparam(alpha,numdata,numclass,aa,bb,numburnin,numiter)

% Modification of Escobar and West.  Works for multiple groups of data.
% numdata, numclass are row vectors, one element per group.

if nargin == 5
    numburnin = 10;
    numiter = 10;
end

totalclass = sum(numclass);
num = length(numdata);
alpha_all = zeros(numburnin+numiter,num);

for ii = 1:numburnin+numiter
    %     xx = randbeta((alpha+1)*ones(1,num),numdata);
    %
    %     zz = rand(1,num).*(alpha+numdata)<numdata;
    %
    %     gammaa = aa + totalclass - sum(zz);
    %     gammab = bb - sum(log(xx));
    %     alpha = randgamma(gammaa)./gammab;
    %
    %     alpha_all(ii,:) = alpha;

    %eta | a,k = B(a+1,n)
    eta = betarnd(alpha+1, numdata);
    %ratio = (a + k - 1)/(n*(b-log(eta)))
    p1 = (aa + totalclass - 1);
    p2 = (numdata*(bb-log(eta)));
    nc = (p1+p2);
    p1 = p1/nc;
    %p2 = p2/nc;
    %p1/p2

    mixcomp = binornd(1,p1);
    if(mixcomp==1)
        alpha = gamrnd(aa+totalclass,bb-log(eta));
    else
        alpha = gamrnd(aa+totalclass-1,bb-log(eta));
    end
    alpha_all(ii,:) = alpha;

end

alpha = mean(alpha_all(numburnin+1:end));
