if doPlot == 1
    subplot(1,totalSubPlot,1);
    cla;
    hold on;
    box on;
    
    plot(dataTrain(1,:),dataTrain(2,:), ...
        '.','color',[0.8 0.8 0.8],'markersize',10,'linewidth',10);
    
    ind = allSelectInd(allSelectInd~=0);
    allSelectedPoint = dataTrain(:,ind);
    allSelectedLabel = labelTrain(ind);
    for c = 1:length(unique(existClass))
        plot(allSelectedPoint(1,allSelectedLabel==existClass(c)), ...
            allSelectedPoint(2,allSelectedLabel==existClass(c)), ...
            '+','color',colourLabel(existClass(c),:), ...
            'markersize',10,'linewidth',2);
    end    
    
    % Display the model
    colour = vsGenPlotColour(length(existClass));
    for nclass = 1:length(existClass)
        for nclust = 1:dpmm{nclass}.K-1
            sigma =  dpmm{nclass}.hp_posterior.B{nclust} / ...
                dpmm{nclass}.hp_posterior.eta(nclust);
            mu =  dpmm{nclass}.hp_posterior.m(:,nclust);
            plotellipse(mu,sigma,'g','linewidth',2);
        end
    end
    
    % Display the prior model
    if exist('priordpmm','var')
        for nclust = 1:priordpmm.K-1
            sigma =  priordpmm.hp_posterior.B{nclust} / ...
                priordpmm.hp_posterior.eta(nclust);
            mu =  priordpmm.hp_posterior.m(:,nclust);
            plotellipse(mu,sigma,'k.','linewidth',1);
        end
    end
    
    % Apply the axis limits
    axis equal;
    axis([-axislimit axislimit -axislimit axislimit]);
    hold off;
    title('DPMM');
    drawnow;
end