%% Random sampling
% See C.C. Loy et al. 'Stream-based Joint Exploration-Exploitation 
% Active Learing', CVPR 2012

addpath('../shared/');
addpath('../external/');
addpath('../external/vdpgm');

% Active learning strategy
sampMethod   = 'rand'; 

% Specify folder to store the result
resultFolder = 'result_rand';

% Specify the number of runs and folds
noRun      = 5;
noFold     = 2;

rf_count = 1;
for nR = 1:noRun
    for nF = 1:noFold
        fprintf('Run %d, fold %d#n',nR,nF);
        
        % Set random seed
        setSeed(rf_count); 
        
        % Call setting script
        globalSetting;
        
        % Active learning routine
        activeLearning;
        
        % Save result
        save(strcat(resultPath,'/',sprintf('result_%d_%d.mat',nR,nF)), ...
            'traceAL','count','allSelectInd','opts');
        
        rf_count = rf_count + 1;
    end
end

if isunix
    delete file.ps;
end
